
:- module(aci_basics,
	[flatten/2,
	 flatten_seq/2,
	 variant/2]).

:- ensure_loaded([library(ordsets), library(lists)]).

flatten(L,LF) :- flatten(L,[],TL), sort(TL,LF).

flatten(V,I,O) :- var(V), !, O = [V|I].
flatten([],I,O) :- !, O = I.
flatten([X|Xs],I,O) :- !, flatten(X,I,XI), flatten(Xs,XI,O).
flatten(T,I,O) :-
	(T=..[N,Arg] ->			% constant or unary function?
	 flatten(Arg,ArgF), TF=..[N,ArgF], O = [TF|I]
	  ;
	 O = [T|I]).			% otherwise collect it


flatten_seq([],[]).
flatten_seq([T|Ts],[FT|FTs]) :- flatten(T,FT), flatten_seq(Ts,FTs).

variant(A,B) :- \+ \+ (numbervars(A,0,N), numbervars(B,0,N), A=B).

