qsort([],[]).
qsort([X|Xs],Sorted) :- 
	partition(Xs,X,Left,Right),
	qsort(Left,LeftS), qsort(Right,RightS),
	append(LeftS,[X|RightS],Sorted).

partition([],_,[],[]).
partition([X|Xs],Pivot,[X|Left],Right) :-
	X =< Pivot,
	partition(Xs,Pivot,Left,Right).
partition([X|Xs],Pivot,Left,[X|Right]) :-
	X > Pivot,
	partition(Xs,Pivot,Left,Right).

append([],L,L).
append([H|L1],L2,[H|L3]) :- append(L1,L2,L3).


/*
qsort(S,Sorted) :-
   qsort(S,Sorted,[]).

partition([],F,[],[]).
partition([F|T],P,[F|S],B) :-
   F =< P,
   partition(T,P,S,B).
partition([F|T],P,S,[F|B]) :-
   F > P,
   partition(T,P,S,B).

qsort([],X,X).
qsort([F|T],Res,Tail) :-
   partition(T,F,S,B),
   qsort(S,Res,[F | Rest]),
   qsort(B,Rest,Tail).  


*/